﻿using System;
using System.Collections.ObjectModel;
using System.Windows.Data;

namespace WpfApp1_gridDuplicates
{
    internal class DataItem
    {
        public string Data1 { get; set; }
    }

    internal class ItemListViewModel 
    {
        private readonly CollectionViewSource _itemListViewSource;
        private ObservableCollection<DataItem> _itemList;

        public Func<DataItem, bool> ItemListViewFilter { get; set; }
        public ListCollectionView ItemListView { get; set; }

        public ObservableCollection<DataItem> ItemList
        {
            get => _itemList;
            set
            {
                _itemList = value;
                _itemList.CollectionChanged += itemList_CollectionChanged;
                _itemListViewSource.Source = value;
                ItemListView = (ListCollectionView)_itemListViewSource.View;
                ItemListView.Filter = o => ItemListViewFilter((DataItem)o);
            }
        }

        public ItemListViewModel( )
        {
            _itemListViewSource = new CollectionViewSource();
            ItemListViewFilter = t => true;
        }

        private void itemList_CollectionChanged( object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e )
        {
            ItemListView = (ListCollectionView)_itemListViewSource.View;

            // Commenting the line below will prevent adding a duplicate
            ItemListView.Filter = o => ItemListViewFilter((DataItem)o);
        }
    }
}
